﻿using System;
using System.Threading;

// Dette program illustrerer synkronisering af tråde vha monitor

namespace Trådeksempel7_MonitorSynk
{
    using System;
    using System.Threading;

    // Dette program illustrerer synkronisering af tråde vha monitor

    // Klasse med trådmetoder
    class Ex7TraadSynk
    {
        private volatile TaellerMonitor taellerMonitor;		// fælles monitor for trådene

        // Konstruktør som medtager monitor
        public Ex7TraadSynk(TaellerMonitor taellerMonitor)
        {
            this.taellerMonitor = taellerMonitor;
        }

        // Tæller én op
        public void Optael()
        {
            while (true)
            {
                taellerMonitor.Optael();
            }
        }

        // Tæller én ned
        public void Nedtael()
        {
            while (true)
            {
                taellerMonitor.Nedtael();
            }
        }

        // Printer tællerværdi på konsol
        public void VisTaeller()
        {
            int taeller;

            while (true)
            {
                taeller = taellerMonitor.GetTaeller();
                Console.WriteLine(taeller);
                Thread.Sleep(1000);
            }
        }
    }
}
