﻿using System;
using System.Threading;

// Dette program illustrerer synkronisering af tråde vha resource-monitor

namespace Trådeksempel7_MonitorSynk
{
    class Program
    {
        static void Main(string[] args)
        {
            Thread optaelTraad, nedtaelTraad, visTraad;
            Ex7TraadSynk traadSynk;
            TaellerMonitor taellerMonitor;

            taellerMonitor = new TaellerMonitor();		// skab resource-monitor

            // skab objekt med trådmetoder (monitor medtages)
            traadSynk = new Ex7TraadSynk(taellerMonitor);

            // Skab tråde
            optaelTraad = new Thread(traadSynk.Optael);
            nedtaelTraad = new Thread(traadSynk.Nedtael);
            visTraad = new Thread(traadSynk.VisTaeller);

            optaelTraad.Start();	// Start tråd, som hele tiden tæller én op
            nedtaelTraad.Start();	// Start tråd, som hele tiden tæller én ned
            visTraad.Start();		// Start tråd, som hele tiden viser tæller-værdi
        }
    }
}
